﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinScrollBar;
using Infragistics.Win.FormattedLinkLabel;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace UltraFormattedTextEditorScroll
{
    public partial class Form1 : Form
    {

        [DllImport("User32.dll")]
        public extern static int GetScrollPos(IntPtr hWnd, int nBar);

        [DllImport("User32.dll")]
        public extern static int SendMessage(IntPtr hWnd, uint msg, IntPtr wParam, IntPtr lParam);

        public enum ScrollBarType : uint
        {
            SbHorz = 0,
            SbVert = 1,
            SbCtl = 2,
            SbBoth = 3
        }

        public enum Message : uint
        {
            WM_VSCROLL = 0x0115,
            WM_HSCROLL = 0x114
        }

        public enum ScrollBarCommands : uint
        {
            SB_THUMBPOSITION = 4
        }


        public Form1()
        {
            InitializeComponent();
            this.ultraFormattedTextEditor1.HScroll += new Infragistics.Win.FormattedLinkLabel.UltraFormattedTextEditorEx.ChangingHandler(this.ultraFormattedTextEditor1_HScroll);
            this.ultraFormattedTextEditor1.VScroll += new Infragistics.Win.FormattedLinkLabel.UltraFormattedTextEditorEx.ChangingHandler(this.ultraFormattedTextEditor1_VScroll);
            //this.ultraFormattedTextEditor2.HScroll += new Infragistics.Win.FormattedLinkLabel.UltraFormattedTextEditorEx.ChangingHandler(this.ultraFormattedTextEditor2_HScroll);
            //this.ultraFormattedTextEditor2.VScroll += new Infragistics.Win.FormattedLinkLabel.UltraFormattedTextEditorEx.ChangingHandler(this.ultraFormattedTextEditor2_VScroll);

            this.richTextBox1.VScroll += new EventHandler(richTextBox1_VScroll);
            this.richTextBox1.HScroll += new EventHandler(richTextBox1_HScroll);

        }

        void richTextBox1_HScroll(object sender, EventArgs e)
        {
            int nPos = GetScrollPos(richTextBox1.Handle, (int)ScrollBarType.SbHorz);
            nPos <<= 16;
            uint wParam = (uint)ScrollBarCommands.SB_THUMBPOSITION | (uint)nPos;
            SendMessage(richTextBox2.Handle, (int)Message.WM_HSCROLL, new IntPtr(wParam), new IntPtr(0));
        }

        void richTextBox1_VScroll(object sender, EventArgs e)
        {
            int nPos = GetScrollPos(richTextBox1.Handle, (int)ScrollBarType.SbVert);
            nPos <<= 16;
            uint wParam = (uint)ScrollBarCommands.SB_THUMBPOSITION | (uint)nPos;
            SendMessage(richTextBox2.Handle, (int)Message.WM_VSCROLL, new IntPtr(wParam), new IntPtr(0));
        }


        private void ultraFormattedTextEditor1_HScroll(object sender, ScrollEventArgs scrollEventArgs)
        {
            int nPos = GetScrollPos(ultraFormattedTextEditor1.Handle, (int)ScrollBarType.SbHorz);
            nPos <<= 16;
            uint wParam = (uint)ScrollBarCommands.SB_THUMBPOSITION | (uint)nPos;
            SendMessage(ultraFormattedTextEditor2.Handle, (int)Message.WM_HSCROLL, new IntPtr(wParam), new IntPtr(0));

            //Infragistics.Win.FormattedLinkLabel.ScrollableAreaUIElement.ContainerElement ce2 = ultraFormattedTextEditor2.UIElement.ChildElements[0].ChildElements[0].ChildElements[0] as Infragistics.Win.FormattedLinkLabel.ScrollableAreaUIElement.ContainerElement;
            //ce2.ChildElements[0].Rect = new Rectangle(-scrollEventArgs.NewValue, ce2.ChildElements[0].Rect.Y, ce2.ChildElements[0].Rect.Width, ce2.ChildElements[0].Rect.Height);
            //ultraFormattedTextEditor2.HScrollBar.AccessibilityInstance.Value = ultraFormattedTextEditor1.HScrollBar.AccessibilityInstance.Value;
            //ultraFormattedTextEditor2.Refresh();
        }


        private void ultraFormattedTextEditor1_VScroll(object sender, ScrollEventArgs scrollEventArgs)
        {
            int nPos = GetScrollPos(ultraFormattedTextEditor1.Handle, (int)ScrollBarType.SbVert);
            nPos <<= 16;
            uint wParam = (uint)ScrollBarCommands.SB_THUMBPOSITION | (uint)nPos;
            SendMessage(ultraFormattedTextEditor2.Handle, (int)Message.WM_VSCROLL, new IntPtr(wParam), new IntPtr(0));

            //Infragistics.Win.FormattedLinkLabel.ScrollableAreaUIElement.ContainerElement ce2 = ultraFormattedTextEditor2.UIElement.ChildElements[0].ChildElements[0].ChildElements[0] as Infragistics.Win.FormattedLinkLabel.ScrollableAreaUIElement.ContainerElement;
            //ce2.ChildElements[0].Rect = new Rectangle(ce2.ChildElements[0].Rect.X, -scrollEventArgs.NewValue, ce2.ChildElements[0].Rect.Width, ce2.ChildElements[0].Rect.Height);
            //ultraFormattedTextEditor2.VScrollBar.AccessibilityInstance.Value = ultraFormattedTextEditor1.VScrollBar.AccessibilityInstance.Value;
            //ultraFormattedTextEditor2.Refresh();
        }

        //private void ultraFormattedTextEditor2_HScroll(object sender, ScrollEventArgs scrollEventArgs)
        //{
        //    Infragistics.Win.FormattedLinkLabel.ScrollableAreaUIElement.ContainerElement ce1 = ultraFormattedTextEditor1.UIElement.ChildElements[0].ChildElements[0].ChildElements[0] as Infragistics.Win.FormattedLinkLabel.ScrollableAreaUIElement.ContainerElement;
        //    ce1.ChildElements[0].Rect = new Rectangle(-scrollEventArgs.NewValue, ce1.ChildElements[0].Rect.Y, ce1.ChildElements[0].Rect.Width, ce1.ChildElements[0].Rect.Height);
        //    ultraFormattedTextEditor1.HScrollBar.AccessibilityInstance.Value = scrollEventArgs.NewValue.ToString();
        //    ultraFormattedTextEditor1.Refresh();
        //}

        //private void ultraFormattedTextEditor2_VScroll(object sender, ScrollEventArgs scrollEventArgs)
        //{
        //    Infragistics.Win.FormattedLinkLabel.ScrollableAreaUIElement.ContainerElement ce2 = ultraFormattedTextEditor1.UIElement.ChildElements[0].ChildElements[0].ChildElements[0] as Infragistics.Win.FormattedLinkLabel.ScrollableAreaUIElement.ContainerElement;
        //    ce2.ChildElements[0].Rect = new Rectangle(ce2.ChildElements[0].Rect.X, -scrollEventArgs.NewValue, ce2.ChildElements[0].Rect.Width, ce2.ChildElements[0].Rect.Height);
        //    ultraFormattedTextEditor1.VScrollBar.AccessibilityInstance.Value = ultraFormattedTextEditor2.VScrollBar.AccessibilityInstance.Value;
        //    ultraFormattedTextEditor1.Refresh();
        //}
    }
}
